﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Windows.Forms;

namespace WindowsFormsControlLibrary1
{
    public partial class UserControl1 : UserControl
    {
        public UserControl1()
        {
            InitializeComponent();
        }

        AccountType _userType;
        [Category("MyUserControlType")]
        public AccountType UserType
        {
            get { return _userType; }
            set { _userType = value; }
        }

        string _guestType;
        [Category("MyUserControlType")]
        [TypeConverter(typeof(UserTypeConverter))]
        [StringList(new string[] { "UserA", "UserB", "UserC" })]
        public string GuestType
        {
            get { return _guestType; }
            set { _guestType = value; }
        }
    }

    public enum AccountType
    {
        A,
        B,
        C
    }

    public class StringListAttribute : Attribute
    {
        string[] _list;
        public string [] List
        {
            get { return _list; }
        }

        public StringListAttribute(string [] list)
        {
            _list = list;
        }
    }

    public class UserTypeConverter : TypeConverter
    {
        public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
        {
            return true;
        }

        public override bool CanConvertTo(ITypeDescriptorContext pContext, Type pDestinationType)
        {
            return base.CanConvertTo(pContext, pDestinationType);
        }

        public override object ConvertTo(ITypeDescriptorContext pContext, CultureInfo pCulture, object pValue, Type pDestinationType)
        {
            return base.ConvertTo(pContext, pCulture, pValue, pDestinationType);
        }

        public override bool CanConvertFrom(ITypeDescriptorContext pContext, Type pSourceType)
        {
            if (pSourceType == typeof(string))
            {
                return true;
            }

            return base.CanConvertFrom(pContext, pSourceType);
        }

        public override object ConvertFrom(ITypeDescriptorContext pContext, CultureInfo pCulture, object pValue)
        {
            if (pValue is string )
            {
                return pValue.ToString();
            }

            return base.ConvertFrom(pContext, pCulture, pValue);
        }

        public override bool GetStandardValuesSupported(ITypeDescriptorContext pContext)
        {
            return true;
        }

        public override StandardValuesCollection GetStandardValues(ITypeDescriptorContext pContext)
        {
            List<string> values = new List<string>();

            AttributeCollection ua = pContext.PropertyDescriptor.Attributes;

            foreach (Attribute attr in ua)
            {
                if (attr is StringListAttribute listAttr)
                {
                    values.AddRange(listAttr.List);
                }
            }

            return new StandardValuesCollection(values);
        }
    }
}
